#include <stdio.h>
#include <iostream.h>
#include <graphics.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>
#include <dos.h>
#include "kb.h"

#define ANGLE_0    0
#define ANGLE_90   480
#define ANGLE_180  960
#define ANGLE_270  1440
#define ANGLE_360  1920

void far *data1 = malloc(17000);
void far *data2 = malloc(17000);
unsigned char map[32][32];
unsigned char pal[1024];
float tan_table[1920];
float cos_table[320];

int tex_off, tex_flag;

int dist(int a, unsigned int x_p, unsigned int y_p)
{
  float x = x_p, y = y_p, m, x_dist, y_dist, x_ = x_p, y_ = y_p;

  if (a == ANGLE_0) a = ANGLE_0 + 1;
  if (a == ANGLE_90) a = ANGLE_90 + 1;
  if (a == ANGLE_180) a = ANGLE_180 + 1;
  if (a == ANGLE_270) a = ANGLE_270 + 1;

  if (a < ANGLE_90 || a > ANGLE_270)
  {
    m = 128 * tan_table[a];
    x = int(x / 128) * 128 + 128;
    y += (x_p - x) * tan_table[a];
    while ((!map[(int)x >> 7][(int)y >> 7]) && (y > 0) && (y < 4096) && (x < 4096))
    {
      x += 128;
      y -= m;
    }
  }
  else
  if (a > ANGLE_90 && a < ANGLE_270)
  {
    m = 128 * tan_table[a];
    x = int(x / 128) * 128;
    y += (x_p - x) * tan_table[a];
    while (!map[(int)(x - 128) >> 7][(int)y >> 7] && y > 0 && x > 0 && y < 4096)
    {
      x -= 128;
      y += m;
    }
  }
  x_dist = sqrt(pow(x - x_p, 2) + pow(y - y_p, 2));

  if (a > ANGLE_180 && a < ANGLE_360)
  {
    m = 128 / tan_table[a];
    y_ = int(y_ / 128) * 128 + 128;
    x_ += (y_p - y_) / tan_table[a];
    while ((!map[(int)x_ >> 7][(int)y_ >> 7]) && (x_ > 0) && (x_ < 4096) && (y_ < 4096))
    {
      y_ += 128;
      x_ -= m;
    }
  }
  else
  if (a < ANGLE_180 && a > ANGLE_0)
  {
    m = 128 / tan_table[a];
    y_ = int(y_ / 128) * 128;
    x_ += (y_p - y_) / tan_table[a];
    while (!map[(int)x_ >> 7][(int)(y_ - 128) >> 7] && x_ > 0 && y_ > 0 && x_ < 4096)
    {
      y_ -= 128;
      x_ += m;
    }
  }
  y_dist = sqrt(pow(x_ - x_p, 2) + pow(y_ - y_p, 2));

  if (x_dist < y_dist && x_dist != 0)
  {
    tex_off = int(y) % 128;
    tex_flag = 0;
    return x_dist;
  }
  if (y_dist < x_dist && y_dist != 0)
  {
    tex_off = int(x_) % 128;
    tex_flag = 1;
    return y_dist;
  }

  return 0;
}

void fill_tables()
{
  float angle = 0;
  for (int i = 0; i < 1920; i++)
  {
    if (angle != ANGLE_90 && angle != ANGLE_270)
      tan_table[i] = sin(angle * M_PI / 180) / cos(angle * M_PI / 180);
    angle += 0.1875;
  }

  for (int i = 0; i < 320; i++)
    cos_table[i] = cos((i * 0.1875 - 30) * M_PI / 180);
}

void set_mode(unsigned int mode)
{
  asm
  {
      mov    ax,  mode
      int    10h
  }
}

void set_rgb(unsigned char n, unsigned char r, unsigned char g, unsigned char b)
{
  asm
  {
      mov    dx,  3C8h
      mov    al,  n
      out    dx,  al
      inc    dx
      mov    al,  r
      shr    al,  2
      out    dx,  al
      mov    al,  g
      shr    al,  2
      out    dx,  al
      mov    al,  b
      shr    al,  2
      out    dx,  al
  }
}

void put_line(int x, int from, int to, unsigned char c1, int off)
{
  char z = tex_flag;
  asm
  {
      push   ds
      cmp    z,   0
      jz     @@4
      lds    si,  data1
      jmp @@5
@@4:  lds    si,  data2
@@5:  mov    ax,  0A000h
      mov    es,  ax
      mov    di,  x
      mov    cx,  200
@1:   mov    al,  c1
      cmp    cx,  from
      jb     @2
      cmp    cx,  to
      ja     @2

      xor    dx,  dx
      mov    ax,  32512
      mov    bx,  to
      sub    bx,  from
      div    bx
      mov    bx,  200
      sub    bx,  cx
      sub    bx,  from
      mul    bx
      shr    ax,  8
      shl    ax,  7
      add    ax,  off
      add    ax,  4
      mov    si,  ax
      mov    al,  ds:[si]

@2:   stosb
      add    di,  319
      loop   @1
      pop    ds
  }
}

void load()
{
  FILE *f;
  int i = 0, j = 0;
  char c;

  f = fopen("059-013.bmp", "rb");
  fseek(f, 54, 0);
  fread(pal, 1024, 1, f);
  fread((unsigned char *)data1, 16384, 1, f);
  fclose(f);
  f = fopen("058-013.bmp", "rb");
  fseek(f, 1078, 0);
  fread((unsigned char *)data2, 16384, 1, f);
  fclose(f);

  f = fopen("map.txt", "rt");

  do
  {
    c = getc(f);
    switch (c)
    {
      case '*': map[i][j] = 1; i++; break;
      case ' ': map[i][j] = 0; i++; break;
      case 10: j++; i = 0;
    }
  }
  while (j < 32);

  fclose(f);
}

void set_pal()
{
  for (int i = 1; i < 256; i++)
    set_rgb(i, pal[i * 4 + 2], pal[i * 4 + 1], pal[i * 4]);
}

void main(int argc, char *argv[])
{
  char key;
  float xp = 2048, yp = 2048, tx, ty;
  float angle_p = 0, angle;
  int color, d, m;

  if (argc == 2)
  {
    angle_p = atof(argv[1]);
  }

  load();
  set_mode(0x13);
  set_pal();
  fill_tables();

  do
  {
    key = inportb(0x60);
    tx = xp;
    ty = yp;
    switch (key)
    {
      case 80: tx += sin((angle_p - 90) * M_PI / 180) * 32;
               ty += cos((angle_p - 90) * M_PI / 180) * 32; break;
      case 72: tx -= sin((angle_p - 90) * M_PI / 180) * 32;
               ty -= cos((angle_p - 90) * M_PI / 180) * 32; break;
      case 77: angle_p += 2; break;
      case 75: angle_p -= 2; break;
    }
    if (!map[int(tx) / 128][int(ty) / 128])
    {
      xp = tx;
      yp = ty;
    }

    if (angle_p > 359) angle_p = 0;
    if (angle_p < 0) angle_p = 359;
    for (int i = 0; i < 320; i++)
    {
      angle = (angle_p - 30) * 5.3333333333 + i;
      if (angle < 0) angle = angle + 1920;
      if (angle > 1920) angle -= 1920;
      d = dist(angle, xp, yp);
      if (d)
      {
        m = 32768 / (d * cos_table[i]);
        if (m > 200) m = 200;
        put_line(i, 100 - m / 2, 100 + m / 2, 252, tex_off);
      }
    }
    K_Reset();
  } while (key != 1);

  set_mode(0x3);
}
