#include <stdio.h>
#include <fstream.h>
#include <iostream.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <dos.h>
#include "mouse.h"
#include "kb.h"

#define ANGLE_0    0
#define ANGLE_90   480
#define ANGLE_180  960
#define ANGLE_270  1440
#define ANGLE_360  1920

void far *data1 = (void far *)new char[16384];
void far *data2 = (void far *)new char[16384];
void far *data3 = (void far *)new char[40960];
void far *buffer = (void far *)new char[64000];
unsigned char map[32][32];
unsigned char pal[1024];
float tan_table[1920];
float cos_table[320];
int tex_off, tex_flag, exit_flag = 0, map_flag = 0;
int l, r, f, b, m_b, m_x, m_a, speed, s_inc = 1;
int r_strafe, l_strafe;
char tex1[14] = "058-013.bmp";
char tex2[14] = "059-013.bmp";

ofstream out;
ifstream in;

void interrupt (*old_vec)(...);

struct vesainfo {
  unsigned int  modeattr        ; // mode attributes
  unsigned char winaattr        ; // window A attributes
  unsigned char winbattr        ; // window B attributes
  unsigned int  granularity     ; // window granularity in K
  unsigned int  windowsize      ; // window size in K
  unsigned int  winaseg         ; // window A start segment
  unsigned int  winbseg         ; // window B start segment
  unsigned long farwindow       ; // far window pointer
  unsigned int  bytesperscan    ; // bytes per scan line
  unsigned int  scrwidth        ; // screen width in pixels
  unsigned int  scrheight       ; // screen height in pixels
  unsigned char charwidth       ; // char width in pixels
  unsigned char charheight      ; // char height in pixels
  unsigned char Nummemplanes    ; // number of memory planes
  unsigned char bitsperpixel    ; // bits per pixel
  unsigned char numofbanks      ; // number of banks
  unsigned char memmodel        ; // memory model
  unsigned char banksize        ; // size of bank in K
  unsigned char numimgpages     ; // number of image pages
  unsigned char reserved[255]   ;
} info;

char far *bmpbuf;
int curbank = 0;

unsigned SetVesaMode(unsigned mode)
{
  unsigned status;

  _ES = FP_SEG((void far *)&info);
  _DI = FP_OFF((void far *)&info);

  asm
  {
    mov ax, 4F01h
    mov cx, mode
    int 10h
    mov ax, 4F02h
    mov bx, mode
    int 10h
    mov status, ax
  }

  return status;
}

int dist(int a, unsigned int x_p, unsigned int y_p)
{
  float x = x_p, y = y_p, m, x_dist, y_dist, x_ = x_p, y_ = y_p;

  if (a == ANGLE_0) a = ANGLE_0 + 1;
  if (a == ANGLE_90) a = ANGLE_90 + 1;
  if (a == ANGLE_180) a = ANGLE_180 + 1;
  if (a == ANGLE_270) a = ANGLE_270 + 1;
  if (a == ANGLE_360) a = ANGLE_360 - 1;

  if (a < ANGLE_90 || a > ANGLE_270)
  {
    m = 128 * tan_table[a];
    x = int(x / 128) * 128 + 128;
    y += (x_p - x) * tan_table[a];
    while ((!map[(int)x >> 7][(int)y >> 7]) && (y > 0) && (y < 4096) && (x < 4096))
    {
      x += 128;
      y -= m;
    }
  }
  else
  if (a > ANGLE_90 && a < ANGLE_270)
  {
    m = 128 * tan_table[a];
    x = int(x / 128) * 128;
    y += (x_p - x) * tan_table[a];
    while (!map[(int)(x - 128) >> 7][(int)y >> 7] && y > 0 && x > 0 && y < 4096)
    {
      x -= 128;
      y += m;
    }
  }
  x_dist = sqrt(pow(x - x_p, 2) + pow(y - y_p, 2));

  if (a > ANGLE_180 && a < ANGLE_360)
  {
    m = 128 / tan_table[a];
    y_ = int(y_ / 128) * 128 + 128;
    x_ += (y_p - y_) / tan_table[a];
    while ((!map[(int)x_ >> 7][(int)y_ >> 7]) && (x_ > 0) && (x_ < 4096) && (y_ < 4096))
    {
      y_ += 128;
      x_ -= m;
    }
  }
  else
  if (a < ANGLE_180 && a > ANGLE_0)
  {
    m = 128 / tan_table[a];
    y_ = int(y_ / 128) * 128;
    x_ += (y_p - y_) / tan_table[a];
    while (!map[(int)x_ >> 7][(int)(y_ - 128) >> 7] && x_ > 0 && y_ > 0 && x_ < 4096)
    {
      y_ -= 128;
      x_ += m;
    }
  }
  y_dist = sqrt(pow(x_ - x_p, 2) + pow(y_ - y_p, 2));

  if ((x_dist < y_dist) && (x_dist != 0))
  {
    tex_off = int(y) % 128;
    tex_flag = 0;
    return x_dist;
  }
  if ((y_dist < x_dist) && (y_dist != 0))
  {
    tex_off = int(x_) % 128;
    tex_flag = 1;
    return y_dist;
  }

  return 0;
}

void fill_tables()
{
  float angle = 0;

  for (int i = 0; i < 1920; i++)
  {
    if (angle != ANGLE_90 && angle != ANGLE_270)
      tan_table[i] = sin(angle * M_PI / 180) / cos(angle * M_PI / 180);
    angle += 0.1875;
  }

  for (int i = 0; i < 320; i++)
    cos_table[i] = cos((i * 0.1875 - 30) * M_PI / 180);
}

void interrupt KB_HANDLER(...)
{
  unsigned char key = inportb(0x60);

  if (key == 15) map_flag = 1;
  if (key == 143) map_flag = 0;

  if (!map_flag)
  switch (key)
  {
    case  1:  exit_flag = 1; break;
    case 80:  b = 1; f = 0; break;
    case 72:  f = 1; b = 0; break;
    case 77:  r = 1; l = 0; break;
    case 75:  l = 1; r = 0; break;
    case 208: b = 0; f = 0; break;
    case 200: f = 0; b = 0; break;
    case 205: r = 0; l = 0; break;
    case 203: l = 0; r = 0; break;
    case  57: speed = 0; break;
    case  42: s_inc = 2; break;
    case 170: s_inc = 1; break;
    case  51: l_strafe = 1; r_strafe = 0; break;
    case 179: l_strafe = 0; break;
    case  52: r_strafe = 1; l_strafe = 0; break;
    case 180: r_strafe = 0; break;
  }

  old_vec();
}

void vert_ret()
{
  asm
  {
    cli
    mov dx, 03DAh
@1: in al, dx
    test al, 8
    jz @1
@2: in al, dx
    test al, 8
    jnz @2
    sti
  }
}

void set_mode(unsigned int mode)
{
  asm
  {
      mov    ax,  mode
      int    10h
  }
}

void set_rgb(unsigned char n, unsigned char r, unsigned char g, unsigned char b)
{
  asm
  {
      mov    dx,  3C8h
      mov    al,  n
      out    dx,  al
      inc    dx
      mov    al,  r
      shr    al,  2
      out    dx,  al
      mov    al,  g
      shr    al,  2
      out    dx,  al
      mov    al,  b
      shr    al,  2
      out    dx,  al
  }
}

void set_pal()
{
  for (int i = 1; i < 256; i++)
    set_rgb(i, pal[i * 4 + 2], pal[i * 4 + 1], pal[i * 4]);
}

void put_sky(int offs)
{
  asm
  {
      push   ds
      push   es
      lds    si,  data3
      les    di,  buffer
      xor    di,  di
      mov    cx,  40960
      rep    movsb
      pop    es
      pop    ds
  }
}

void put_buf()
{
  asm
  {
      push   ds
      lds    si,  buffer
      mov    ax,  0A000h
      mov    es,  ax
      xor    di,  di
      mov    cx,  64000
      rep    movsb
      pop    ds
  }
}

void PutPixel(int x, int y, unsigned color)
{
  int bytes = 640;

  asm
  {
      push   0A000h
      pop    es
      xor    dx,  dx
      mov    ax,  y
      mul    bytes
      shl    x,  1
      add    ax,  x
      jnc    @@1
      inc    dx
@@1:  cmp    dx,  curbank
      je     @@2
      push   ax
      mov    curbank,  dx
      mov    ax,  4F05h
      xor    bx,  bx
      int    10h
      pop    ax
@@2:  mov    di,  ax
      mov    ax,  color
      stosw
  }
}

void put_line(int x, int from, int to, unsigned char c1, int off, int m)
{
  unsigned color, c, r, g, b, a, index;
  unsigned c_, c2, c3;
  double mul_const = 0.01 * m;
  for (int i = 0; i < 200; i++)
  {
    if (i <= from)
    {
      asm
      {
        xor dx, dx
        mov ax, i
        mov bx, 320
        mul bx
        add ax, x
        mov a, ax
      }
      c = *((unsigned char *)data3 + a);
      r = pal[(c << 2) + 2];
      g = pal[(c << 2) + 1];
      b = pal[(c << 2)];
      asm
      {
        mov ax, r
        shr ax, 3
        shl ax, 10
        mov bx, g
        shr bx, 3
        shl bx, 5
        add ax, bx
        mov bx, b
        shr bx, 3
        add ax, bx
        mov color, ax
      }
      PutPixel(x, i, color);
    }
    else
    if (i > from && i < to)
    {
      index = (int)((128 / (double)(to - from)) * (i - from));
      asm
      {
        mov ax, index
        shl ax, 7
        add ax, off
        mov a, ax
      }
      if (tex_flag)
        c = *((unsigned char *)data1 + a);
      else
        c = *((unsigned char *)data2 + a);
      c_ = pal[(c << 2) + 2];
      c2 = pal[(c << 2) + 1];
      c3 = pal[(c << 2)];
      r = (int)((double)c_ * mul_const);
      if (r > c_) r = c_;
      g = (int)((double)c2 * mul_const);
      if (g > c2) g = c2;
      b = (int)((double)c3 * mul_const);
      if (b > c3) b = c3;
      asm
      {
        mov ax, r
        shr ax, 3
        shl ax, 10
        mov bx, g
        shr bx, 3
        shl bx, 5
        add ax, bx
        mov bx, b
        shr bx, 3
        add ax, bx
        mov color, ax
      }
      PutPixel(x, i, color);
    }
    else
      PutPixel(x, i, 0);
  }
}

void bar(int x, int y, int w, int h, char color)
{
  asm
  {
      mov    ax,  0A000h
      mov    es,  ax
      mov    di,  y
      shl    di,  8
      mov    bx,  y
      shl    bx,  6
      add    di,  bx
      add    di,  x
      mov    al,  color
      mov    cx,  h
@@1:  push   cx
      mov    cx,  w
      rep    stosb
      sub    di,  w
      add    di,  320
      pop    cx
      loop   @@1
  }
}

void draw_map(int x, int y)
{
  for (int i = 0; i < 32; i++)
    for (int j = 0; j < 32; j++)
      if (map[i][j] > 0)
        bar(i * 4 + 96, j * 3 + 52, 4, 3, 16);
  bar(x / 128 * 4 + 96, y / 128 * 3 + 52, 4, 3, 242);
}

void load()
{
  int i = 0, j = 0;
  char c;

  FILE *in = fopen(tex1, "rb");
  if (!in) throw "Unable to load texture\n";
  fseek(in, 54, 0);
  fread(pal, 1024, 1, in);
  fread((unsigned char *)data1, 16384, 1, in);
  fclose(in);
  in = fopen(tex2, "rb");
  if (!in) throw "Unable to load texture\n";
  fseek(in, 1078, 0);
  fread((unsigned char *)data2, 16384, 1, in);
  fclose(in);
  in = fopen("sky.bmp", "rb");
  if (!in) throw "Unable to load texture\n";
  fseek(in, 1078, 0);
  fread((unsigned char *)data3, 40960, 1, in);
  fclose(in);
  in = fopen("map.txt", "rt");
  if (!in) throw "Unable to load map\n";

  do
  {
    c = getc(in);
    switch (c)
    {
      case '*': map[i][j] = 1; i++; break;
      case ' ': map[i][j] = 0; i++; break;
      case 10: j++; i = 0;
    }
  }
  while (j < 32);

  fclose(in);
}

void print_help()
{
  cout << "\n3D World. Version 1.5.\n";
  cout << "Copyright (c) 1999 by MATI Inc.\n\n";
  cout << "\t Usage: 3DWORLD [options <files>]\n\n";
  cout << "Options:\n";
  cout << "\t-r  Record demo to <filename>\n";
  cout << "\t-p  Play demo from <filename>\n";
  cout << "\t-t  Load two alternate textures\n";
}

void check_command_line(int argc, char *argv1, char *argv2, char *argv3)
{
  for (int i = 0; i < strlen(argv1); i++)
    argv1[i] = toupper(argv1[i]);
  for (int j = 0; j < strlen(argv2); j++)
    argv2[j] = toupper(argv2[j]);

  if (argc >= 2)
  {
    if (!strcmp(argv1, "-R"))
    {
      out.open(argv2);
      if (!out || argc < 3)
        throw "Unable to open demo file\n";
    }
    else
    if (!strcmp(argv1, "-P"))
    {
      in.open(argv2);
      if (!in || argc < 3)
        throw "Unable to open demo file\n";
    }
    else
    if (!strcmp(argv1, "-T"))
    {
      if (!in || argc < 4)
        throw "Unable to load texture\n";
      strcpy(tex1, argv2);
      strcpy(tex2, argv3);
    }
    else
    if (!strcmp(argv1, "-?"))
    {
      print_help();
      throw "";
    }
    else
      throw "Unknown command option.\nType \"-?\" for help.\n";;
  }
}

int main(int argc, char *argv[])
{
  unsigned char key;
  int xp = 2048, yp = 2048, tx, ty;
  int angle_p = 90, angle;
  int color, d, m, s_speed;

  try
  {
    check_command_line(argc, argv[1], argv[2], argv[3]);
  }
  catch (const char *message)
  {
    cout << message;
    return 0;
  }

  try
  {
    load();
  }
  catch (const char *error)
  {
    cout << error;
    return 1;
  }

  if (SetVesaMode(0x10D)!=0x004F)
  {
    cout << "Error initializing mode\n";
    return 1;
  }

//  set_mode(0x13);
//  set_pal();
  fill_tables();

  old_vec = getvect(0x09);
  setvect(0x09, KB_HANDLER);
  ReadMouseCount(m_a, m_x);

  do
  {
    tx = xp;
    ty = yp;

    MouseRead(m_b, m_b, m_b);

    if (!map_flag)
    {
      ReadMouseCount(m_a, m_x);

      angle_p += m_a / 4;
      d = dist(int(angle_p * 5.3333333), xp, yp);
      if (m_x > d) m_x = d - 10;
      if (fabs(m_x) / 2 > fabs(speed)) speed = m_x / 2;

      if (b) speed = 16;
      if (f || (m_b == 1)) speed = -16;
      if (l_strafe)
        s_speed = 16;
      if (r_strafe)
        s_speed = -16;
      if (r_strafe || l_strafe)
      {
        tx += int(sin((angle_p) * M_PI / 180) * s_speed * s_inc / 2);
        ty += int(cos((angle_p) * M_PI / 180) * s_speed * s_inc / 2);
      }

      tx += int(sin((angle_p - 90) * M_PI / 180) * speed * s_inc);
      ty += int(cos((angle_p - 90) * M_PI / 180) * speed * s_inc);
      if (speed < 0) speed++;
      if (speed > 0) speed--;

      if (r) angle_p += 2;
      if (l) angle_p -= 2;
      if (angle_p > 359) angle_p -= 360;
      if (angle_p < 0) angle_p += 360;
    }

    if ((tx % 128 > 64) && map[tx / 128 + 1][ty / 128])
      tx = tx / 128 * 128 + 64;
    else
    if ((tx % 128 < 64) && map[tx / 128 - 1][ty / 128])
      tx = tx / 128 * 128 + 64;
    if ((ty % 128 > 64) && map[tx / 128][ty / 128 + 1])
      ty = ty / 128 * 128 + 64;
    else
    if ((ty % 128 < 64) && map[tx / 128][ty / 128 - 1])
      ty = ty / 128 * 128 + 64;

    xp = tx;
    yp = ty;

    if ((in) && (!out))
    {
      in >> xp;
      in >> yp;
      in >> angle_p;
      if (!in)
      {
        in.close();
        in.open(argv[2]);
      }
    }

    if (map_flag)
      draw_map(xp, yp);
    else
//    put_sky(0);
    for (int i = 0; i < 320; i++)
    {
      angle = ((angle_p - 30) * 53 + i * 10) / 10;
      if (angle < 0) angle = angle + 1920;
      if (angle > 1920) angle -= 1920;
      d = dist(angle, xp, yp);
      if (d)
      {
        m = 32768 / (d * cos_table[i]);
        if (m > 200)
          put_line(i, 0, m, 199, tex_off, m);
        else
          put_line(i, 100 - m / 2, 100 + m / 2, 80, tex_off, m);
      }
    }

    if (out)
    {
      out << xp << " ";
      out << yp << " ";
      out << angle_p << "\n";
    }
//   put_buf();

    K_Reset();
  } while (!exit_flag);

  setvect(0x09, old_vec);

  set_mode(0x3);
  out.close();
  in.close();
  cout << "Copyright (c) 1999 by MATI Inc.\n";

  return 0;
}
